<?php
/**
 * @version		$Id: index.php,v 1.26 2010/07/01 22:42:49 juanca Exp $
 * @package		vpl. List all instances in a course
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/
class vpl_list_util{
	static $fields;   //field to compare
	static $ascending; //value to return when ascending or descending order

	static public function cpm($avpl,$bvpl){ //Compare two submission fields
		$a = $avpl->get_instance();
		$b = $bvpl->get_instance();
		foreach(self::$fields as $field){
			$avalue = $a->$field;
			$bvalue = $b->$field;
			if($avalue == $bvalue){
				continue;
			}elseif($avalue < $bvalue){
				return self::$ascending;
			}else{
				return -self::$ascending;
			}
		}
		return 0;
	}

	/**
	 * Check and set data to sort return comparation function
	 * $field field to compare
	 * $descending order
	 */
	static public function set_order($field,$ascending = true){
		$sortfields = array('name'=>array('name'),
		'shortdescription' => array('shortdescription'),
		'visiblefrom' => array('visiblefrom','availablefrom','duedate','name'),
		'availablefrom' => array('availablefrom','duedate','name'),
		'duedate' => array('duedate','availablefrom','name'),
		'automaticgrading' => array('automaticgrading','duedate','name'));
		if(isset($sortfields[$field])){
			self::$fields = $sortfields[$field];
		}else{ //Unknow field
			self::$fields = $sortfields['duedate'];
		}
		if($ascending){
			self::$ascending = -1;
		}else{
			self::$ascending = 1;
		}
	}
	static public function vpl_list_arrow($burl,$sort,$instanceselection){
		$newdir = 'down'; //Dir to go if click
		$url = vpl_url_add_param($burl,'sort',$sort);
		$url = vpl_url_add_param($url,'selection',$instanceselection);
		if($sort == optional_param('sort','duedate', PARAM_ALPHA)){
			$sortdir = optional_param('sortdir','down', PARAM_ALPHA);
			if($sortdir == 'up'){
				$newdir = 'down';
			}elseif($sortdir == 'down'){
				$newdir = 'up';
			}else{ //Unknow sortdir
				$sortdir = 'down';
			}
			$url = vpl_url_add_param($url,'sortdir',$newdir);
		}else{
			$sortdir = 'move';
		}
		return '<a href="'.$url.'">'.print_arrow($sortdir,'',true).'</a>';
	}
	static public function count_graded($vpl){ //Count submissions graded
		$subs = $vpl->all_last_user_submission();
		$students = get_users_by_capability($vpl->get_context(), 'moodle/legacy:student', '', '', '', '', '', '', false);
		$numsubs = 0;
		$numgraded = 0;
		if(is_array($subs)){
			foreach($subs as $sub){
				if(isset($students[$sub->userid])){
					$numsubs++;
					if($sub->dategraded > 0){ //is graded
						$numgraded++;
					}
				}
			}
		}
		return array('submissions' => $numsubs, 'graded' => $numgraded);
	}
}

require_once dirname(__FILE__).'/../../config.php';
require_once dirname(__FILE__).'/locallib.php';
$id = required_param('id', PARAM_INT);   // course
$sort=optional_param('sort','duedate', PARAM_ALPHA);
$sortdir = optional_param('sortdir','down', PARAM_ALPHA);
$instanceselection = optional_param('selection','all', PARAM_ALPHA);
require_login($id); //Check login state

//Check course existence
if (! $course = get_record("course", "id", $id)) {
	print_error('invalidcourseid','',$id);
}

add_to_log($course->id, VPL, 'view all', "index.php?id=$course->id", '');
//Load strings
//TODO add instance information about submissions and grading
$burl = vpl_rel_url(basename(__FILE__),'id',$id);
$strname  				= get_string('name').' '.vpl_list_util::vpl_list_arrow($burl,'name',$instanceselection);
$strvpls 				= get_string('modulenameplural',VPL);
$strshortdescription 	= get_string('shortdescription', VPL).' '.vpl_list_util::vpl_list_arrow($burl,'shortdescription',$instanceselection);
$strvisiblefrom			= get_string('visiblefrom', VPL).' '.vpl_list_util::vpl_list_arrow($burl,'visiblefrom',$instanceselection);
$stravailablefrom		= get_string('availablefrom', VPL).' '.vpl_list_util::vpl_list_arrow($burl,'availablefrom',$instanceselection);
$strduedate				= get_string('duedate', VPL).' '.vpl_list_util::vpl_list_arrow($burl,'duedate',$instanceselection);
$strnopls 				= get_string('novpls', VPL);

$navlinks = array();
$navlinks[] = array('name' => $strvpls, 'link' => '', 'type' => 'activity');
$navigation = build_navigation($navlinks);

print_header($strvpls, $course->fullname, $navigation, '', '', false, '', navmenu($course));

//Print selection by instance state

echo '&nbsp;';
popup_form(vpl_mod_href('index.php','id',$id,'sort',$sort,'sortdir',$sortdir).'&amp;selection=',
array('all' => get_string('all'),
	'open' => get_string('open',VPL),'closed' => get_string('closed',VPL),
	'timelimited' => get_string('timelimited',VPL),'timeunlimited' => get_string('timeunlimited',VPL),
	'automaticgrading' => get_string('automaticgrading',VPL),'manualgrading' => get_string('manualgrading',VPL)),
'selectionmenu',
$instanceselection, '', '', '', false, 'self', get_string('instanceselection',VPL));
echo '<br />';
@ob_flush();
flush();

if (!$cms = get_coursemodules_in_course(VPL, $course->id,"m.shortdescription, m.visiblefrom, m.availablefrom, m.duedate")) {
	notice($strnopls, vpl_abs_href('/course/view.php','id',$course->id));
	die;
}
$timenow = time();
$vpls = array();
//Get and select vpls to show
foreach ($cms as $cmid => $cm) {
	$vpl = new mod_vpl($cmid);
	$instance = $vpl->get_instance();
	if ($vpl->is_visible() && $vpl->has_capability(VPL_VIEW_CAPABILITY)) {
		switch($instanceselection){
			case 'all':
				$vpls[]=$vpl;
				break;
			case 'open':
				$min = $instance->availablefrom;
				$max = $instance->duedate == 0 ? PHP_INT_MAX:$instance->duedate;
				if($timenow >= $min && $timenow <= $max){
					$vpls[]=$vpl;
				}
				break;
			case 'closed':
				$min = $instance->availablefrom;
				$max = $instance->duedate == 0 ? PHP_INT_MAX:$instance->duedate;
				if($timenow < $min || $timenow > $max){
					$vpls[]=$vpl;
				}
				break;
			case 'timelimited':
				if($instance->duedate > 0){
					$vpls[]=$vpl;
				}
				break;
			case 'timeunlimited':
				if($instance->duedate == 0){
					$vpls[]=$vpl;
				}
				break;
			case 'automaticgrading':
				if($instance->grade !=0 && $instance->automaticgrading > 0){
					$vpls[]=$vpl;
				}
				break;
			case 'manualgrading':
				if($instance->grade !=0 && $instance->automaticgrading == 0){
					$vpls[]=$vpl;
				}
				break;
		}
	}
}
//Is the user a grader?
$grader = false;
foreach ($vpls as $vpl) {
	if($vpl->has_capability(VPL_GRADE_CAPABILITY)){
		$grader = true;
		break;
	}
}

//usort of old PHP versions don't call static class functions
$corder = new vpl_list_util;
$corder->set_order($sort,optional_param('sortdir','down', PARAM_ALPHA)=='down');
usort($vpls,array($corder,'cpm'));
//Generate table
$table->head  = array ($strname, $strshortdescription,$strvisiblefrom,$stravailablefrom,$strduedate);
$table->align = array ('left', 'left', 'rigth', 'rigth', 'rigth');
if($grader){	
	$table->head[] = get_string('submissions',VPL);
	$table->head[] = get_string('graded',VPL);
	$table->align[] = 'rigth';
	$table->align[] = 'rigth';
}
foreach ($vpls as $vpl) {
	$instance = $vpl->get_instance();
	$url = vpl_rel_url('view.php','id',$vpl->get_course_module()->id);
	$row = array ("<a href='$url'>{$instance->name}</a>",
	$instance->shortdescription,
	$instance->visiblefrom>0?userdate($instance->visiblefrom):'',
	$instance->availablefrom>0?userdate($instance->availablefrom):'',
	$instance->duedate>0?userdate($instance->duedate):'');
	if($grader){
		if($vpl->has_capability(VPL_GRADE_CAPABILITY)){
			$info = vpl_list_util::count_graded($vpl);
			$row[]=$info['submissions'];
			$row[]=$info['graded'];
		}else{
			$row[]='';
			$row[]='';
		}
	}
	$table->data[] = $row;
}

echo "<br />";
print_table($table);
print_footer($course);

?>