<?php
/**
 * @version		$Id: similarity_form.class.php,v 1.10 2010/06/18 20:11:55 juanca Exp $
 * @package		vpl. Similarity form class
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

global $CFG;
require_once dirname(__FILE__).'/../../../config.php';
require_once $CFG->libdir.'/formslib.php';
require_once $CFG->dirroot.'/backup/lib.php';
class vpl_similarity_form extends moodleform {
	private $vpl;
	function __construct($page,$vpl){
		$this->vpl = $vpl;
		parent::__construct($page);
	}
	function list_activities($vplid){
		$courses=array();
		$list=array(''=>'');
		//TODO may have a performance problem
		$vpls = get_records(VPL);
		foreach($vpls as $vpl){
			if($vpl->id == $vplid){
				continue;
			}
			$cm = get_coursemodule_from_instance(VPL,$vpl->id);
			if($cm){
				$context =get_context_instance(CONTEXT_MODULE,$cm->id);
				if(has_capability(VPL_SIMILARITY_CAPABILITY, $context)){
					if(!isset($courses[$cm->course])){
						$course=get_record("course", "id", $cm->course);
						$courses[$cm->course]=$course->shortname;
					}
					$list[$cm->id]=$courses[$cm->course].' '.$vpl->name;
				}
			}
		}
		asort($list);
		$list['']=get_string('select');
		return $list;
	}
	
	function get_directories($dirpath){
        $ret = array();
        $dd = @opendir($dirpath);
        if($dd !== false){
	        while ($dir=readdir($dd)) {
	            if ($dir!='.' && $dir!='..' && is_dir($dirpath."/".$dir)) {
	                $ret[] = $dir;
	            }
	        }
        	closedir($dd);
        }
        return $ret;
    }

	function list_directories($cid){
		global $CFG;
		$dirs=array();
		$dirs=array('' => get_string('select'));
		$basedir=$CFG->dataroot.'/'.$cid;
		foreach($this->get_directories($basedir) as $dir){
			$dirs[$dir]=$dir;
			foreach($this->get_directories($basedir.'/'.$dir) as $inner){
				$dirs[$dir.'/'.$inner]=$dir.'/'.$inner;
			}
		}
		return $dirs;
	}
	function definition(){
		$mform    =& $this->_form; 
        $mform->addElement('hidden','id',required_param('id',PARAM_INT));
		$filelist = $this->vpl->get_required_fgm()->getFileList();
		if(count($filelist)>0){
	        $mform->addElement('header', 'headerfilestoprocess', get_string('filestoscan', VPL));
			$num=0;
			foreach($filelist as $filename){
				$mform->addElement('checkbox','file'.$num,$filename);
				$mform->setDefault('file'.$num, true);
				$mform->disabledIf('file'.$num, 'allfiles','checked');
				$num++;
			}
			$mform->addElement('checkbox','allfiles',get_string('allfiles',VPL));
			$mform->addElement('checkbox','joinedfiles',get_string('joinedfiles',VPL));
			$mform->disabledIf('joinedfiles', 'allfiles','checked');
		}else{
			$mform->addElement('hidden','allfiles','checked');
		}
		$mform->addElement('header', 'headerfilestoprocess', get_string('scanoptions', VPL));
        $options=array();
        for($i=5; $i<=40; $i+=5){
        	$options[$i]=$i;
        }
        for($i=60; $i<=100; $i+=20){
        	$options[$i]=$i;
        }
        for($i=150; $i<=400; $i+=50){
        	$options[$i]=$i;
        }
        $mform->addElement('select', 'maxoutput', get_string('maxsimilarityoutput',VPL), $options);
        $mform->setType('maxoutput', PARAM_INT);
        $cid=$this->vpl->get_course()->id;
		$mform->addElement('header', 'headerothersources', get_string('othersources', VPL));
        $mform->addElement('select', 'scanactivity', get_string('scanactivity',VPL),$this->list_activities($this->vpl->get_instance()->id));
        $mform->addElement('choosecoursefile', 'scanzipfile0', get_string('scanzipfile', VPL), array('courseid'=>$cid));
        $mform->addElement('choosecoursefile', 'scanzipfile1', get_string('scanzipfile', VPL), array('courseid'=>$cid));
        $mform->addElement('select', 'scandirectory', get_string('scandirectory', VPL), $this->list_directories($cid));
        $mform->addElement('checkbox','searchotherfiles',get_string('scanother',VPL));
        $mform->setDefault('searchotherfiles', true);
        $this->add_action_buttons(false,get_string('search'));
	}
}
?>