<?php
/**
 * @version		$Id: downloadsubmission.php,v 1.11 2010/01/19 18:01:03 juanca Exp $
 * @package		vpl. Download submission in zip file
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once dirname(__FILE__).'/../similarity/watermark.php';
require_once dirname(__FILE__).'/../../../config.php';
global $CFG, $USER;
require_once dirname(__FILE__).'/../locallib.php';
require_once dirname(__FILE__).'/../vpl.class.php';
require_once dirname(__FILE__).'/../vpl_submission.class.php';

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$instance = $vpl->get_instance();
$userid = optional_param('userid',FALSE,PARAM_INT);
$submissionid =  optional_param('submissionid',FALSE,PARAM_INT);
//Read record
if($userid && $userid != $USER->id){
	//Grader
	$vpl->require_capability(VPL_GRADE_CAPABILITY);
	$grader =TRUE;
	if($submissionid){
		$subinstance = get_record('vpl_submissions','id',$submissionid);
	}else{
		$subinstance = $vpl->last_user_submission($userid);
	}
}
else{
	//view own submission
	$vpl->require_capability(VPL_VIEW_CAPABILITY);
	$userid = $USER->id;
	$grader = FALSE;
	if($submissionid && $vpl->has_capability(VPL_GRADE_CAPABILITY)){
		$subinstance = get_record('vpl_submissions','id',$submissionid);
	}else{
		$subinstance = $vpl->last_user_submission($userid);
	}
	$vpl->password_check();
}

//Check consistence
if(!$subinstance){
	notice(get_string('nosubmission',VPL),vpl_mod_href('view.php','id',$id,'userid',$userid));
}
if($subinstance->vpl != $vpl->get_instance()->id){
	print_error('invalidcourseid');
}
$submissionid = $subinstance->id;

if($subinstance->userid != $userid){
	error('vpl submission user inconsistence');
}
if($vpl->get_instance()->id != $subinstance->vpl){
	error('vpl submission vpl inconsistence');
}
$submission = new mod_vpl_submission($vpl,$subinstance);

//TODO change to new zip class when available
//Get class to handle zip
require_once($CFG->libdir . '/filelib.php');
require_once($CFG->libdir . '/pclzip/pclzip.lib.php');

//Make a temp dir and copy and transform code to be compressed

$dirfilename=tempnam($CFG->dataroot . '/temp/'  , 'vpl_dirdownload' );
$destdir=$dirfilename.'.dir';
mkdir($destdir,0700);
$destdir.='/';
unlink($dirfilename);
$zipfilename=tempnam($CFG->dataroot . '/temp/'  , 'vpl_zipdownload' );
$zip = new PclZip($zipfilename);
$filelist = vpl_read_list_from_file($submission->get_submissionfilelistname());
$origdir = $submission->get_submission_directory();
$filenames=array();
foreach ($filelist as $filename) {
	if($filename > ''){
		//TODO add vpl option to switch on/off watermark system
		vpl_watermark::addfilewm($origdir.$filename,$destdir.$filename,$userid);
		$filenames[]=$destdir.$filename;
	}
}
if ($zip->create($filenames, '',$destdir)==0) {
    error("cannot create zip file");
}
//delete temporal dir
foreach ($filenames as $filename) {
	unlink($filename);
}
rmdir($destdir);
//Get zip data
$data=file_get_contents($zipfilename);
//remove zip file
unlink($zipfilename);
send_file($data,$instance->name.'.zip',0,0,true,true);
?>